package	jp.co.sds_corp.util.daemon.remote;

import java.io.Serializable;

import jp.co.sds_corp.util.config.IConfigSavable;
import jp.co.sds_corp.util.config.IConfigurable;

/**
* デーモンマネージャを外部から制御するクライアントクラスの定義です。
*/
public interface IRemoteClient extends IConfigurable, IConfigSavable,
										Serializable
{
	/**
	* クライアントのタイプを返します。
	*/
	public String getType();

	/**
	* リモートのメソッドを呼び出します。
	* @param    cmd     メソッド名
	* @param    cls     パラメータのクラス
	* @param    prm     パラメータのオブジェクト
	*/
	public Object execRemote( String cmd, Class<?>[] cls, Object[] prm )
		throws Exception;
	/**
	* リモートのメソッドを呼び出します。
	* @param    cmd     メソッド名
	*/
	public Object execRemote( String cmd )
		throws Exception;

	/**
	* 処理を終了します。
	*/
	public void exit();

	/**
	* 接続を開始します。
	*/
	public void connect() throws Exception;
	/**
	* 接続を終了します。
	*/
	public void disconnect() throws Exception;

	/**
	* 接続しているかを取得します。
	* @return	接続しているか
	*/
	public boolean isConnected();

}
